'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _nodeFetch = require('node-fetch');

var _nodeFetch2 = _interopRequireDefault(_nodeFetch);

var _cheerio = require('cheerio');

var _cheerio2 = _interopRequireDefault(_cheerio);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Lyricist = function () {
  function Lyricist(accessToken) {
    _classCallCheck(this, Lyricist);

    if (!accessToken) throw new Error('No access token provided!');
    this.accessToken = accessToken;
  }

  /*
  Main request function
  */

  _createClass(Lyricist, [{
    key: '_request',
    value: function () {
      var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(path) {
        var url, response, json, parsed;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                url = 'https://api.genius.com/' + path;
                _context.next = 3;
                return (0, _nodeFetch2.default)(url, {
                  headers: { 'Authorization': 'Bearer ' + this.accessToken }
                });

              case 3:
                response = _context.sent;
                _context.next = 6;
                return response.text();

              case 6:
                json = _context.sent;
                parsed = JSON.parse(json);

                if (parsed.meta.status !== 200) {
                  // throw new Error(parsed.meta.status);
                }
                return _context.abrupt('return', parsed.response);

              case 10:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function _request(_x) {
        return _ref.apply(this, arguments);
      }

      return _request;
    }()

    /*
    Search song by ID
    */

  }, {
    key: 'song',
    value: function () {
      var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(id, opts) {
        var path, response, song, lyrics;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (id) {
                  _context2.next = 2;
                  break;
                }

                throw new Error('No ID was provided to lyricist.song()');

              case 2:
                path = 'songs/' + id;
                _context2.next = 5;
                return this._request(path);

              case 5:
                response = _context2.sent;
                song = response.song;
                lyrics = null;

                if (!(opts && opts.fetchLyrics)) {
                  _context2.next = 12;
                  break;
                }

                _context2.next = 11;
                return this._scrapeLyrics(song.url);

              case 11:
                lyrics = _context2.sent;

              case 12:
                return _context2.abrupt('return', Object.assign({ lyrics: lyrics }, song));

              case 13:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function song(_x2, _x3) {
        return _ref2.apply(this, arguments);
      }

      return song;
    }()

    /*
    Get album by ID
    */

  }, {
    key: 'album',
    value: function () {
      var _ref3 = _asyncToGenerator(regeneratorRuntime.mark(function _callee3(id, opts) {
        var path, response, album, tracklist;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (id) {
                  _context3.next = 2;
                  break;
                }

                throw new Error('No ID was provided to lyricist.album()');

              case 2:
                path = 'albums/' + id;
                _context3.next = 5;
                return this._request(path);

              case 5:
                response = _context3.sent;
                album = response.album;
                tracklist = null;

                if (!(opts && opts.fetchTracklist)) {
                  _context3.next = 12;
                  break;
                }

                _context3.next = 11;
                return this._scrapeTracklist(album.url);

              case 11:
                tracklist = _context3.sent;

              case 12:
                return _context3.abrupt('return', Object.assign({ tracklist: tracklist }, album));

              case 13:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function album(_x4, _x5) {
        return _ref3.apply(this, arguments);
      }

      return album;
    }()

    /* Get artist */

  }, {
    key: 'artist',
    value: function () {
      var _ref4 = _asyncToGenerator(regeneratorRuntime.mark(function _callee4(id, opts) {
        var path, response;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (id) {
                  _context4.next = 2;
                  break;
                }

                throw new Error('No ID was provided to lyricist.artist()');

              case 2:
                path = 'artists/' + id;
                _context4.next = 5;
                return this._request(path);

              case 5:
                response = _context4.sent;
                return _context4.abrupt('return', response.artist);

              case 7:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function artist(_x6, _x7) {
        return _ref4.apply(this, arguments);
      }

      return artist;
    }()

    /* Get artist songs */

  }, {
    key: 'songsByArtist',
    value: function () {
      var _ref5 = _asyncToGenerator(regeneratorRuntime.mark(function _callee5(id, opts) {
        var page, perPage, sort, path, response, songs;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                if (id) {
                  _context5.next = 2;
                  break;
                }

                throw new Error('No ID was provided to lyricist.songsByArtist()');

              case 2:
                page = opts && opts.page || 1;
                perPage = opts && opts.perPage || 20;
                sort = opts && opts.sort || 'title';
                path = 'artists/' + id + '/songs?per_page=' + perPage + '&page=' + page + '&sort=' + sort;
                _context5.next = 8;
                return this._request(path);

              case 8:
                response = _context5.sent;
                songs = response.songs;
                return _context5.abrupt('return', songs);

              case 11:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function songsByArtist(_x8, _x9) {
        return _ref5.apply(this, arguments);
      }

      return songsByArtist;
    }()
  }, {
    key: 'search',
    value: function () {
      var _ref6 = _asyncToGenerator(regeneratorRuntime.mark(function _callee6(query, opts) {
        var path, response;
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                if (query) {
                  _context6.next = 2;
                  break;
                }

                throw new Error('No search query was provided to lyricist.search()');

              case 2:
                path = 'search?q=' + query;
                _context6.next = 5;
                return this._request(path);

              case 5:
                response = _context6.sent;
                return _context6.abrupt('return', response.hits.map(function (hit) {
                  return hit.result;
                }));

              case 7:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function search(_x10, _x11) {
        return _ref6.apply(this, arguments);
      }

      return search;
    }()

    /*
    Scrape tracklist
    */

  }, {
    key: '_scrapeTracklist',
    value: function () {
      var _ref7 = _asyncToGenerator(regeneratorRuntime.mark(function _callee7(url) {
        var response, text, $, songs;
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return (0, _nodeFetch2.default)(url);

              case 2:
                response = _context7.sent;
                _context7.next = 5;
                return response.text();

              case 5:
                text = _context7.sent;
                $ = _cheerio2.default.load(text);
                songs = $('.primary_list li').map(function (i, el) {
                  return {
                    id: $(el).data('id'),
                    title: $(el).find('.song_title').text()
                  };
                });
                return _context7.abrupt('return', songs.toArray());

              case 9:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function _scrapeTracklist(_x12) {
        return _ref7.apply(this, arguments);
      }

      return _scrapeTracklist;
    }()

    /* Scrape song lyrics */

  }, {
    key: '_scrapeLyrics',
    value: function () {
      var _ref8 = _asyncToGenerator(regeneratorRuntime.mark(function _callee8(url) {
        var response, text, $;
        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return (0, _nodeFetch2.default)(url);

              case 2:
                response = _context8.sent;
                _context8.next = 5;
                return response.text();

              case 5:
                text = _context8.sent;
                $ = _cheerio2.default.load(text);
                return _context8.abrupt('return', $('.lyrics').text().trim());

              case 8:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function _scrapeLyrics(_x13) {
        return _ref8.apply(this, arguments);
      }

      return _scrapeLyrics;
    }()
  }]);

  return Lyricist;
}();

exports.default = Lyricist;